# Fish Redux

<img src="https://img.alicdn.com/tfs/TB1r74NJyLaK1RjSZFxXXamPFXa-1024-1024.png" width="128px" height="128px">

## What is Fish Redux ?

Fish Redux is an assembled flutter application framework based on Redux state management.
It is suitable for building medium and large applications.

It has four characteristics:

> 1. Functional Programming

> 2. Predictable state container

> 3. Pluggable componentization

> 4. Non-destructive performance

## Architecture diagram

<img src="https://img.alicdn.com/tfs/TB1pkhoJr2pK1RjSZFsXXaNlXXa-1004-1370.png" width="500px" height="680px">

## Documents

Language: [English](doc/README.md) | [中文简体](doc/README-cn.md)

## Examples

-   [todo list](example) - a simple todo list demo.
-   run it:

```
cd ./example
flutter create .
flutter run
```

## What's the difference between 'Fish Redux' and 'Redux' ?

-   [answers](doc/concept/what's-the-diiference.md)

## License

-   Fish Redux is released under the Apache 2.0 license. See [LICENSE](LICENSE) for details.
